 /***********************************************************************/                          
 /*  By:      Alan Campin                                               */                          
 /*  Date:    05/02/2006                                                */                          
 /*  Purpose: Extract CL Commands from a source member. This            */                          
 /*             command is used by other modules to extract all         */                          
 /*             CL commands flagged with a *_> from a source            */                          
 /*             file and places them in a data queue.                   */                          
 /*                                                                     */                          
 /*           Note: Must be created by hand as this command is          */                          
 /*                    part of compile utility. Must be compiled        */                          
 /*                                                                     */                          
 /*     ALLOW(*BPGM *IPGM *BMOD *IMOD *BREXX *IREXX)                    */                          
 /* ---------------------------------------------------------------     */                          
 /*  Command processor: XV0003C                                         */                          
 /*----------------------------------------------------------------  */                             
 /* Program Modification Section:                                    */                             
 /*                                                                  */                             
 /*  By..:                                                           */                             
 /*  Date:                                                           */                             
 /*  Desc:                                                           */                             
 /*                                                                  */                             
 /********************************************************************/                             
             CMD        PROMPT('Extract Source Commands')                                           
                                                                                                    
             PARM       KWD(SRCMBR) TYPE(*NAME) LEN(10) MIN(1) +                                    
                          PROMPT('Source member' 1)                                                 
                                                                                                    
             PARM       KWD(SRCFILE) TYPE(Q1) PROMPT('Source file' 2)                               
                                                                                                    
 Q1:         QUAL       TYPE(*NAME) LEN(10) DFT(QSRCF)                                              
             QUAL       TYPE(*NAME) LEN(10) DFT(*LIBL) SPCVAL(*LIBL) +                              
                          PROMPT('Library')                                                         
                                                                                                    
             PARM       KWD(EXPAND) TYPE(*CHAR) LEN(1) RSTD(*YES) +                                 
                          DFT(*YES) SPCVAL((*YES Y) (*NO N)) +                                      
                          PROMPT('Expand @n parms' 3)                                               
                                                                                                    
             PARM       KWD(SUBDATA) TYPE(*CHAR) LEN(128) +                                         
                          PROMPT('Substitution data' 4)                                             
                                                                                                    
             PARM       KWD(DATAQ) TYPE(Q2) PROMPT('Data queue' 5)                                  
                                                                                                    
 Q2:         QUAL       TYPE(*NAME) LEN(10) DFT(XVCMDQ)                                             
             QUAL       TYPE(*NAME) LEN(10) RSTD(*YES) DFT(QTEMP) +                                 
                          VALUES(QTEMP) PROMPT('Library')                                           
                                                                                                    
             PARM       KWD(RTNCNT) TYPE(*DEC) LEN(5 0) RTNVAL(*YES) +                              
                          PROMPT('CL var for RTNCNT      (5,0)' 6)                                  
