 /********************************************************************/                             
 /*  Program: XV0003C                                                */                             
 /*  Desc:    CPP for EXTSRCCMD. Setup for call to XV0003AR to       */                             
 /*             extract commands from source member.                 */                             
 /*  By:      Alan Campin                                            */                             
 /*  Date:    09/08/2005                                             */                             
 /*----------------------------------------------------------------  */                             
 /* Program Modification Section:                                    */                             
 /*                                                                  */                             
 /*  By..:                                                           */                             
 /*  Date:                                                           */                             
 /*  Desc:                                                           */                             
 /*                                                                  */                             
 /********************************************************************/                             
             PGM        PARM(&SRCM &SRCF_LIB &EXPAND &SUBDTA +                                      
                          &DATAQ_LIB &RTNCNT)                                                       
                                                                                                    
             DCL        VAR(&SRCM) TYPE(*CHAR) LEN(10) /* Member to +                               
                          extract CL commands from. */                                              
             DCL        VAR(&SRCF_LIB) TYPE(*CHAR) LEN(20) /* +                                     
                          Qualified Source File Name. */                                            
             DCL        VAR(&EXPAND) TYPE(*CHAR) LEN(1) /* Expand @n +                              
                          parms in line. */                                                         
             DCL        VAR(&SUBDTA) TYPE(*CHAR) LEN(128) /* +                                      
                          Substitution data. */                                                     
             DCL        VAR(&DATAQ_LIB) TYPE(*CHAR) LEN(20) /* +                                    
                          Qualified data queue name. */                                             
             DCL        VAR(&RTNCNT) TYPE(*DEC) LEN(5 0) /* Return +                                
                          count of CL Commands extracted from +                                     
                          member. */                                                                
                                                                                                    
             DCL        VAR(&SRCF) TYPE(*CHAR) LEN(10)                                              
             DCL        VAR(&SRCFL) TYPE(*CHAR) LEN(10)                                             
             DCL        VAR(&DATAQ) TYPE(*CHAR) LEN(10)                                             
             DCL        VAR(&DATAQL) TYPE(*CHAR) LEN(10)                                            
             DCL        VAR(&EXIST) TYPE(*CHAR) LEN(1)                                              
                                                                                                    
             DCL        VAR(&MSGID) TYPE(*CHAR) LEN(7)                                              
             DCL        VAR(&MSGF) TYPE(*CHAR) LEN(10)                                              
             DCL        VAR(&MSGFLIB) TYPE(*CHAR) LEN(10)                                           
             DCL        VAR(&MSGDTA) TYPE(*CHAR) LEN(256)                                           
                                                                                                    
/*Unmonitored message handler                                                */                    
                                                                                                    
             MONMSG     MSGID(CPF0000) EXEC(GOTO CMDLBL(HANDLE_ERR))                                
                                                                                                    
/*Split the qualified name into program fields.                              */                    
                                                                                                    
             CHGVAR     VAR(&SRCF) VALUE(%SUBSTRING(&SRCF_LIB 1 10))                                
             CHGVAR     VAR(&SRCFL) VALUE(%SUBSTRING(&SRCF_LIB 11 10))                              
                                                                                                    
             CHGVAR     VAR(&DATAQ) VALUE(%SUBSTRING(&DATAQ_LIB 1 10))                              
             CHGVAR     VAR(&DATAQL) VALUE(%SUBSTRING(&DATAQ_LIB 11 +                               
                          10))                                                                      
                                                                                                    
/*Validate that source file exists and we have read authority.               */                    
                                                                                                    
             CHKOBJ     OBJ(&SRCFL/&SRCF) OBJTYPE(*FILE) AUT(*OBJEXIST)                             
                                                                                                    
             CHKOBJ     OBJ(&SRCFL/&SRCF) OBJTYPE(*FILE) MBR(&SRCM) +                               
                          AUT(*READ)                                                                
                                                                                                    
/*Check to see if data queue exists. If yes, delete and recreate.            */                    
                                                                                                    
             CHGVAR     VAR(&EXIST) VALUE('Y')                                                      
             CHKOBJ     OBJ(&DATAQL/&DATAQ) OBJTYPE(*DTAQ) AUT(*ALL)                                
             MONMSG     MSGID(CPF0000) EXEC(CHGVAR VAR(&EXIST) +                                    
                          VALUE('N'))                                                               
             IF         COND(&EXIST *EQ 'Y') THEN(DO)                                               
               DLTDTAQ    DTAQ(&DATAQL/&DATAQ)                                                      
             ENDDO                                                                                  
                                                                                                    
             CRTDTAQ    DTAQ(&DATAQL/&DATAQ) MAXLEN(1024) +                                         
                          TEXT('Command Data Queue.') AUT(*ALL)                                     
                                                                                                    
/*Remove any messages.                                                       */                    
                                                                                                    
             RMVMSG     CLEAR(*ALL)                                                                 
                                                                                                    
/*Point to source file and member.                                           */                    
                                                                                                    
             OVRDBF     FILE(QSRCF) TOFILE(&SRCFL/&SRCF) +                                          
                          MBR(&SRCM) SEQONLY(*YES 12)                                               
                                                                                                    
/*Call XV0003AR to extract commands.                                         */                    
                                                                                                    
             CALL       PGM(XV0003AR) PARM(&SRCF &SRCFL &SRCM +                                     
                          &EXPAND &SUBDTA &DATAQ &DATAQL &RTNCNT)                                   
                                                                                                    
/*Send any messages back to caller.                                          */                    
                                                                                                    
RCVMSG:                                                                                             
             RCVMSG     MSGDTA(&MSGDTA) MSGID(&MSGID) MSGF(&MSGF) +                                 
                          MSGFLIB(&MSGFLIB)                                                         
             MONMSG     MSGID(CPF0000) EXEC(GOTO CMDLBL(ENDRCV))                                    
             IF         COND(&MSGID *EQ ' ') THEN(GOTO CMDLBL(ENDRCV))                              
             SNDPGMMSG  MSGID(&MSGID) MSGF(&MSGFLIB/&MSGF) +                                        
                          MSGDTA(&MSGDTA)                                                           
             MONMSG     MSGID(CPF0000)                                                              
             GOTO       CMDLBL(RCVMSG)                                                              
ENDRCV:                                                                                             
                                                                                                    
/*Clean up.                                                                  */                    
                                                                                                    
             DLTOVR     FILE(*ALL)                                                                  
                                                                                                    
             RETURN                                                                                 
                                                                                                    
/*Handle unmonitored errors.                                                 */                    
                                                                                                    
HANDLE_ERR:                                                                                         
             RCVMSG     MSGTYPE(*EXCP) MSGDTA(&MSGDTA) MSGID(&MSGID) +                              
                          MSGF(&MSGF) MSGFLIB(&MSGFLIB)                                             
             MONMSG     MSGID(CPF0000) EXEC(GOTO CMDLBL(END_ABNORM))                                
             IF         COND(&MSGID *EQ ' ') THEN(GOTO +                                            
                          CMDLBL(END_ABNORM))                                                       
             SNDPGMMSG  MSGID(&MSGID) MSGF(&MSGFLIB/&MSGF) +                                        
                          MSGDTA(&MSGDTA) MSGTYPE(*DIAG)                                            
             GOTO       CMDLBL(HANDLE_ERR)                                                          
END_ABNORM:                                                                                         
             SNDPGMMSG  MSGID(CPF9898) MSGF(QCPFMSG) MSGDTA('Command +                              
                          EXTSRCCMD ended abnormally! See previous +                                
                          messages for reason!') MSGTYPE(*ESCAPE)                                   
                                                                                                    
             ENDPGM                                                                                 
