 /*********88888888***********************************************************/                     
 /*  Program: XV0005C                                                        */                     
 /*  By:      Alan Campin                                                    */                     
 /*  Date:    09/08/2005                                                     */                     
 /*  Purpose: Command Processor for COMPILE. Does setup for                  */                     
 /*            EXCSRCMD. Takes source file name, member name,                */                     
 /*            object name and library runs EXCSRCMD.                        */                     
 /*------------------------------------------------------------------------- */                     
 /*  Called by: Command COMPILE                                              */                     
 /*------------------------------------------------------------------------- */                     
 /* Program Modification Section:                                            */                     
 /*  By..:                                                                   */                     
 /*  Date:                                                                   */                     
 /*  Desc:                                                                   */                     
 /*                                                                          */                     
 /*******************************************************************        */                     
             PGM        PARM(&OBJNPL &SRCFL &SRCMBR &JOBDESC +                                      
                          &OPTIMOPM &OPTIMILE &DEBUGVIEW &ENV +                                     
                          &BATCH &GUIMSGQ)                                                          
                                                                                                    
             DCL        VAR(&OBJNPL) TYPE(*CHAR) LEN(20) /* +                                       
                          Qualified object name to create. */                                       
             DCL        VAR(&SRCFL) TYPE(*CHAR) LEN(20) /* Source +                                 
                          file name. */                                                             
             DCL        VAR(&SRCMBR) TYPE(*CHAR) LEN(10) /* Source +                                
                          member name. */                                                           
             DCL        VAR(&JOBDESC) TYPE(*CHAR) LEN(20) /* Job +                                  
                          description to use. */                                                    
             DCL        VAR(&OPTIMOPM) TYPE(*CHAR) LEN(4) /* +                                      
                          Optimize for Original Program Model *YES +                                
                          or *NO. */                                                                
             DCL        VAR(&OPTIMILE) TYPE(*CHAR) LEN(6) /* +                                      
                          Optimize for ILE Module. *NONE, *BASIC, +                                 
                          *FULL. */                                                                 
             DCL        VAR(&DEBUGVIEW) TYPE(*CHAR) LEN(7) /* ILE +                                 
                          module debug view level *STMT, *SOURCE, +                                 
                          *LIST, *COPY, *ALL, *NONE. */                                             
             DCL        VAR(&BATCH) TYPE(*CHAR) LEN(1) /* Process in +                              
                          Batch? Y or N. */                                                         
             DCL        VAR(&ENV) TYPE(*CHAR) LEN(1) /* Environment +                               
                          running in *Workstation(W) or *GUI(G)? */                                 
             DCL        VAR(&GUIMSGQ) TYPE(*CHAR) LEN(20) /* +                                      
                          Message Queue to send GUI message to. */                                  
                                                                                                    
             DCL        VAR(&SRCF) TYPE(*CHAR) LEN(10)                                              
             DCL        VAR(&SRCL) TYPE(*CHAR) LEN(10)                                              
             DCL        VAR(&OBJNAM) TYPE(*CHAR) LEN(10)                                            
             DCL        VAR(&OBJLIB) TYPE(*CHAR) LEN(10)                                            
             DCL        VAR(&JOBDN) TYPE(*CHAR) LEN(10)                                             
             DCL        VAR(&JOBDL) TYPE(*CHAR) LEN(10)                                             
             DCL        VAR(&GUIMSGQN) TYPE(*CHAR) LEN(10)                                          
             DCL        VAR(&GUIMSGQL) TYPE(*CHAR) LEN(10)                                          
             DCL        VAR(&USER) TYPE(*CHAR) LEN(10)                                              
             DCL        VAR(&OBJOWN) TYPE(*CHAR) LEN(10)                                            
             DCL        VAR(&SUBDTA) TYPE(*CHAR) LEN(128)                                           
             DCL        VAR(&MSGQNAM) TYPE(*CHAR) LEN(10)                                           
             DCL        VAR(&MSGQLIB) TYPE(*CHAR) LEN(10)                                           
                                                                                                    
             DCL        VAR(&MSGID) TYPE(*CHAR) LEN(7)                                              
             DCL        VAR(&MSGDTA) TYPE(*CHAR) LEN(100)                                           
             DCL        VAR(&MSGF) TYPE(*CHAR) LEN(10)                                              
             DCL        VAR(&MSGFLIB) TYPE(*CHAR) LEN(10)                                           
             DCL        VAR(&REPLY) TYPE(*CHAR) LEN(1)                                              
                                                                                                    
/*Unmonitored message handler                                                */                    
                                                                                                    
             MONMSG     MSGID(CPF0000) EXEC(GOTO CMDLBL(HANDLE_ERR))                                
                                                                                                    
/*Split the qualified name into program fields.                              */                    
                                                                                                    
             CHGVAR     VAR(&SRCF) VALUE(%SUBSTRING(&SRCFL 1 10))                                   
             CHGVAR     VAR(&SRCL) VALUE(%SUBSTRING(&SRCFL 11 10))                                  
                                                                                                    
             CHGVAR     VAR(&OBJNAM) VALUE(%SUBSTRING(&OBJNPL 1 10))                                
             CHGVAR     VAR(&OBJLIB) VALUE(%SUBSTRING(&OBJNPL 11 10))                               
                                                                                                    
             CHGVAR     VAR(&JOBDN) VALUE(%SUBSTRING(&JOBDESC 1 10))                                
             CHGVAR     VAR(&JOBDL) VALUE(%SUBSTRING(&JOBDESC 11 10))                               
                                                                                                    
/*Validate that the source file exists and we have rights to read.           */                    
                                                                                                    
             CHKOBJ     OBJ(&SRCL/&SRCF) OBJTYPE(*FILE) AUT(*USE)                                   
                                                                                                    
             CHKOBJ     OBJ(&SRCL/&SRCF) OBJTYPE(*FILE) MBR(&SRCMBR) +                              
                          AUT(*READ)                                                                
                                                                                                    
/*Validate that Object library exists.                                       */                    
                                                                                                    
             CHKOBJ     OBJ(QSYS/&OBJLIB) OBJTYPE(*LIB) AUT(*USE)                                   
                                                                                                    
/*Validate that Job Description exists, if compiling in batch.               */                    
                                                                                                    
             IF         COND(&BATCH *EQ 'Y') THEN(DO)                                               
               CHKOBJ     OBJ(&JOBDL/&JOBDN) OBJTYPE(*JOBD) AUT(*USE)                               
             ENDDO                                                                                  
                                                                                                    
/*Extract Gui Message queue if something other than *USER                    */                    
                                                                                                    
             CHGVAR     VAR(&GUIMSGQN) VALUE(%SUBSTRING(&GUIMSGQ 1 10))                             
             CHGVAR     VAR(&GUIMSGQL) VALUE(%SUBSTRING(&GUIMSGQ 11 +                               
                          10))                                                                      
                                                                                                    
/*Get user running job.                                                      */                    
                                                                                                    
             RTVJOBA    CURUSER(&USER)                                                              
                                                                                                    
/*Prepare substitution data. Current parameters are:                         */                    
/*                                                                            */                    
/*  @1 = Source file.                                                        */                    
/*  @2 = Source file library.                                                */                    
/*  @3 = Source member.                                                      */                    
/*  @4 = Object name.                                                        */                    
/*  @5 = Object library.                                                     */                    
/*  @6 = Optimize *YES or *NO (Original Program Model.                       */                    
/*  @7 = Object owner.                                                       */                    
/*  @8 = Optimize ILE.                                                       */                    
/*  @9 = ILE Module Debug View.                                              */                    
                                                                                                    
             CHGVAR     VAR(&SUBDTA) VALUE(&SRCF *TCAT ';' *CAT +                                   
                          &SRCL *TCAT ';' *CAT &SRCMBR *TCAT ';' +                                  
                          *CAT &OBJNAM *TCAT ';' *CAT &OBJLIB *TCAT +                               
                          ';' *CAT &OPTIMOPM *TCAT ';' *CAT &OBJOWN +                               
                          *TCAT ';' *CAT &OPTIMILE *TCAT ';' *CAT +                                 
                          &DEBUGVIEW)                                                               
                                                                                                    
/*If Running in GUI enviroment, create a message queue to hold messages      */                    
/*  for send back to this level.                                             */                    
                                                                                                    
             CHGVAR     VAR(&MSGQNAM) VALUE('*USER')                                                
             IF         COND(&ENV *EQ 'G') THEN(DO)                                                 
               DLTMSGQ    MSGQ(QTEMP/HOLDMSGS)                                                      
               MONMSG     MSGID(CPF0000)                                                            
               CRTMSGQ    MSGQ(QTEMP/HOLDMSGS) TEXT('Temp to hold +                                 
                            messages') AUT(*ALL)                                                    
               CHGVAR     VAR(&MSGQNAM) VALUE('HOLDMSGS')                                           
               CHGVAR     VAR(&MSGQLIB) VALUE('QTEMP')                                              
             ENDDO                                                                                  
                                                                                                    
/*Submit EXCSRCCMD command.                                                  */                    
                                                                                                    
             RMVMSG     CLEAR(*ALL)                                                                 
             IF         COND(&BATCH *EQ 'N') THEN(DO)                                               
               IF         COND(&ENV *EQ 'G') THEN(DO)                                               
                 EXCSRCCMD  SRCMBR(&SRCMBR) SRCFILE(&SRCL/&SRCF) +                                  
                              SUBDATA(&SUBDTA) MESSAGEQ(&MSGQLIB/&MSGQNAM)                          
               ENDDO                                                                                
               ELSE       CMD(DO)                                                                   
                 EXCSRCCMD  SRCMBR(&SRCMBR) SRCFILE(&SRCL/&SRCF) +                                  
                              SUBDATA(&SUBDTA) MESSAGEQ(*USER)                                      
                 SNDPGMMSG  MSGID(CPF9898) MSGF(QCPFMSG) +                                          
                              MSGDTA('EXCSRCCMD executed interactively!')                           
               ENDDO                                                                                
             ENDDO                                                                                  
             ELSE       CMD(DO)     /* Run in Batch. If *GUI, cannot run BAT */                     
               SBMJOB     CMD(EXCSRCCMD SRCMBR(&SRCMBR) +                                           
                            SRCFILE(&SRCL/&SRCF) SUBDATA(&SUBDTA) +                                 
                            MESSAGEQ(*USER)) JOB(&SRCMBR) +                                         
                            JOBD(&JOBDL/&JOBDN)                                                     
               RCVMSG     MSGDTA(&MSGDTA) MSGID(&MSGID) MSGF(&MSGF) +                               
                            MSGFLIB(&MSGFLIB)                                                       
               SNDPGMMSG  MSGID(&MSGID) MSGF(&MSGFLIB/&MSGF) +                                      
                            MSGDTA(&MSGDTA)                                                         
             ENDDO                                                                                  
                                                                                                    
/*If running in a GUI environment, get message out message queue and send to */                    
/*  this level to display in log.                                            */                    
                                                                                                    
             IF         COND(&ENV *EQ 'G') THEN(DO)                                                 
RCVMSG:                                                                                             
               RCVMSG     MSGQ(&MSGQLIB/&MSGQNAM) MSGTYPE(*INQ) +                                   
                            MSGDTA(&MSGDTA) MSGID(&MSGID) MSGF(&MSGF) +                             
                            MSGFLIB(&MSGFLIB)                                                       
               MONMSG     MSGID(CPF0000) EXEC(GOTO CMDLBL(ENDRCV))                                  
               IF         COND(&MSGID *EQ ' ') THEN(GOTO CMDLBL(ENDRCV))                            
                                                                                                    
/*Send messages to User message queue or selected GUI message queue. */                            
                   IF         COND(&GUIMSGQN *EQ '*USER') THEN(DO)                                  
                     SNDPGMMSG  MSGID(&MSGID) MSGF(&MSGFLIB/&MSGF) +                                
                                  MSGDTA(&MSGDTA) TOUSR(&USER) MSGTYPE(*INFO)                       
                   ENDDO                                                                            
                   ELSE       CMD(DO)                                                               
                     SNDPGMMSG  MSGID(&MSGID) MSGF(&MSGFLIB/&MSGF) +                                
                                  MSGDTA(&MSGDTA) +                                                 
                                  TOMSGQ(&GUIMSGQL/&GUIMSGQN) MSGTYPE(*INFO)                        
                   ENDDO                                                                            
                                                                                                    
               GOTO       CMDLBL(RCVMSG)                                                            
ENDRCV:                                                                                             
               DLTMSGQ    MSGQ(&MSGQLIB/&MSGQNAM)                                                   
               MONMSG     MSGID(CPF0000)                                                            
             ENDDO                                                                                  
                                                                                                    
/*Return to the caller.                                                      */                    
                                                                                                    
             RETURN                                                                                 
                                                                                                    
/*Unmonitored error processing routine                                       */                    
                                                                                                    
HANDLE_ERR:                                                                                         
             RCVMSG     MSGTYPE(*EXCP) MSGDTA(&MSGDTA) MSGID(&MSGID) +                              
                          MSGF(&MSGF) MSGFLIB(&MSGFLIB)                                             
             MONMSG     MSGID(CPF0000) EXEC(GOTO CMDLBL(END_ABNORM))                                
             IF         COND(&MSGID *EQ ' ') THEN(GOTO +                                            
                          CMDLBL(END_ABNORM))                                                       
             SNDPGMMSG  MSGID(&MSGID) MSGF(&MSGFLIB/&MSGF) +                                        
                          MSGDTA(&MSGDTA) MSGTYPE(*DIAG)                                            
             GOTO       CMDLBL(HANDLE_ERR)                                                          
END_ABNORM:                                                                                         
             SNDPGMMSG  MSGID(CPF9898) MSGF(QCPFMSG) MSGDTA('Command +                              
                          COMPILE ended abnormally! See previous +                                  
                          messages for reason!') MSGTYPE(*ESCAPE)                                   
                                                                                                    
             ENDPGM                                                                                 
